/*
 *      Copyright (c) 2004 on behalf of the EU EGEE Project:
 *      The European Organization for Nuclear Research (CERN),
 *      Istituto Nazionale di Fisica Nucleare (INFN), Italy
 *      Datamat Spa, Italy
 *      Centre National de la Recherche Scientifique (CNRS), France
 *      CS Systeme d'Information (CSSI), France
 *      Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
 *      Universiteit van Amsterdam (UvA), Netherlands
 *      University of Helsinki (UH.HIP), Finland
 *      University of Bergen (UiB), Norway
 *      Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom
 *
 *      GLite Data IO Client module: IO Errors
 *
 *      Authors: Paolo Badino <paolo.badino@cern.ch>
 *      Version info: $Id: ioerrors.h,v 1.2 2005/08/09 10:15:52 zfarkas Exp $
 *      Release: $Name: glite-data-io-client_R_1_5_2 $
 *
 *      Revision history:
 *      $Log: ioerrors.h,v $
 *      Revision 1.2  2005/08/09 10:15:52  zfarkas
 *      Instead of "Unsupported file type" error msg tell what the problem is (lfn/guid problem)
 *
 *      Revision 1.1  2004/08/30 13:26:45  badino
 *      Added to Source Control
 *
 *
 */

#ifndef GLITE_DATA_IO_IOERRORS_H_
#define GLITE_DATA_IO_IOERRORS_H_

// Currently, Glite IO Errors are mapped to the aiod one, but this could be 
// changed when the io-daemon will be refactored
// TODO Look also at posix Error codes
#include "glite/data/io/daemon/aioerror.hxx"

#define GLITE_IO_SUCCESS                AIO_SUCCESS
#define GLITE_IO_ERROR                  AIO_ERROR
#define GLITE_IO_REMOTEERROR            AIO_REMOTEERROR
#define GLITE_IO_OPENERROR              AIO_OPENERROR
#define GLITE_IO_OPENAGAIN              AIO_OPENAGAIN
#define GLITE_IO_READINWRITESESSION     AIO_READINWRITESESSION
#define GLITE_IO_WRITEINREADSESSION     AIO_WRITEINREADSESSION
#define GLITE_IO_SEEKINWRITESESSION     AIO_SEEKINWRITESESSION
#define GLITE_IO_NETREADERROR           AIO_NETREADERROR
#define GLITE_IO_NETWRITEERROR          AIO_NETWRITEERROR
#define GLITE_IO_REMOTEREADERROR        AIO_REMOTEREADERROR
#define GLITE_IO_REMOTEWRITEERROR       AIO_REMOTEWRITEERROR
#define GLITE_IO_CONNECTIONERROR        AIO_CONNECTIONERROR
#define GLITE_IO_ILLEGALGUID            AIO_ILLEGALGUID
#define GLITE_IO_ACCESSDENIED           AIO_ACCESSDENIED
#define GLITE_IO_FILENOTEXISTING        AIO_FILENOTEXISTING
#define GLITE_IO_FILENAMETOOLONG        AIO_FILENAMETOOLONG
#define GLITE_IO_MAXBLOCKEXCEEDED       AIO_MAXBLOCKEXCEEDED
#define GLITE_IO_REMOTEFILESIZEERROR    AIO_REMOTEFILESIZEERROR
#define GLITE_IO_WRITEISEXCLUSIVE       AIO_WRITEISEXCLUSIVE
#define GLITE_IO_SERVERFULL             AIO_SERVERFULL
#define GLITE_IO_LOCALREADERROR         AIO_LOCALREADERROR
#define GLITE_IO_LOCALWRITEERROR        AIO_LOCALWRITEERROR
#define GLITE_IO_NOENVELOPE             AIO_NOENVELOPE
#define GLITE_IO_CRYPTENVERROR          AIO_CRYPTENVERROR
#define GLITE_IO_DECRYPTENVERROR        AIO_DECRYPTENVERROR
#define GLITE_IO_KEYERROR               AIO_KEYERROR
#define GLITE_IO_NOSERVERSSLSUPPORT     AIO_NOSERVERSSLSUPPORT
#define GLITE_IO_NOCLIENTSSLSUPPORT     AIO_NOCLIENTSSLSUPPORT
#define GLITE_IO_NOCACHE                AIO_NOCACHE
#define GLITE_IO_CACHEZOMBIE            AIO_CACHEZOMBIE
#define GLITE_IO_REDIRECTED             AIO_REDIRECTED

// New ones
#define GLITE_IO_CONFIGERROR            -0x500
#define GLITE_IO_NOTIMPLEMENTED         -0x501
#define GLITE_IO_INVALIDHANDLE          -0x502

// Error codes related to file names
#define GLITE_IO_NAME_OK		0
#define GLITE_IO_NULL_NAME		-0x503
#define GLITE_IO_INVALID_GUID		-0x504
#define GLITE_IO_INVALID_LFN		-0x505

#endif //GLITE_DATA_IO_IOERRORS_H_
