<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>

<xsl:template match="index">
<services>
    <xsl:apply-templates select="document(sd)/services/service" mode="sd"/>
    <xsl:apply-templates select="document(io/file)/service/components/component[@name='io-client']" mode="io">
        <xsl:with-param name="filename" select="io/name"/>
    </xsl:apply-templates>
</services>
</xsl:template>

<xsl:template match="service" mode="sd">
    <xsl:copy-of select="."/>
</xsl:template>

<xsl:template match="component" mode="io">
    <xsl:param name="filename"/>
    <service>
        <xsl:attribute name="name">
            <xsl:value-of select="$filename"/>
        </xsl:attribute>
        <parameters>
            <endpoint>
                <xsl:text>gliteio://</xsl:text>
                <xsl:value-of select="init/param[@name='Server']/value"/>
                <xsl:text>:</xsl:text>
                <xsl:value-of select="init/param[@name='ServerPort']/value"/>
            </endpoint>
            <type>
                <xsl:text>org.glite.GliteIO</xsl:text>
            </type>
            <version>2.2.0</version>
            <site></site>
            <param name="encryptname">
                <xsl:value-of select="init/param[@name='EncryptName']/value"/>
            </param>
            <param name="encryptdata">
                <xsl:value-of select="init/param[@name='EncryptData']/value"/>
            </param>
            <param name="streamnum">2</param>
            <param name="cahcelevel">6</param>
        </parameters>
    </service>
</xsl:template>

</xsl:stylesheet>
